#!/usr/bin/python
from gi.repository import Gtk, Gio

felder = "kelvin-feld", "celsius-feld", "fahrenheit-feld", "reaumur-feld", "rankine-feld"
wert = {}
widget = {}
handler = {}

class TemperaturApp(Gtk.Application):

    def __init__(self):
        Gtk.Application.__init__(self, application_id="apps.test.temperatur",
                                 flags=Gio.ApplicationFlags.FLAGS_NONE)
        self.connect("activate", self.on_activate)

    def geaendert(self, objekt, was):
        wert[was] = widget[was].get_value()
        if was == "celsius-feld":
            wert["kelvin-feld"] = wert["celsius-feld"] + 273.15
        elif was == "fahrenheit-feld":
            wert["kelvin-feld"] = (5.0/9.0)*(wert["fahrenheit-feld"]-32.0) + 273.15
        elif was == "reaumur-feld":
            wert["kelvin-feld"] = (5.0/4.0)*wert["reaumur-feld"] + 273.15
        elif was == "rankine-feld":
            wert["kelvin-feld"] = (5.0/9.0)*wert["rankine-feld"]
	
        if was != "celsius-feld":
            wert["celsius-feld"] = wert["kelvin-feld"] - 273.15
        if was != "fahrenheit-feld":
            wert["fahrenheit-feld"] = (9.0/5.0)*(wert["kelvin-feld"]-273.15) + 32.0
        if was != "reaumur-feld":
            wert["reaumur-feld"] = (4.0/5.0)*(wert["kelvin-feld"]-273.15)
        if was != "rankine-feld":
            wert["rankine-feld"] = (9.0/5.0)*wert["kelvin-feld"]

        for i in felder:
            if was != i:
                widget[i].handler_block(handler[i])
                widget[i].set_value(wert[i])
                widget[i].handler_unblock(handler[i])

    def on_activate(self, data=None):
        builder = Gtk.Builder()
        builder.add_from_file("temperatur.gtkbuilder")
        for i in (("fenster", "schliessknopf") + felder):
            widget[i] = builder.get_object(i)
        for i in felder:
            handler[i] = widget[i].connect("value_changed", self.geaendert, i)
        widget["schliessknopf"].connect_object("clicked", Gtk.Window.destroy, widget["fenster"])
        widget["fenster"].show_all()
        self.add_window(widget["fenster"])
        widget["celsius-feld"].set_value(100)
    
if __name__ == "__main__":
    app = TemperaturApp()
    app.run(None)
